package net.pdynet.odbcproxyclient;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;

import org.apache.http.entity.AbstractHttpEntity;
import org.apache.http.entity.ContentType;

public class JaxbEntity extends AbstractHttpEntity {
	
	private Object content;
	
	public JaxbEntity(Object obj, ContentType contentType) {
		this.content = obj;
		
		if (contentType != null)
			setContentType(contentType.toString());
	}

	@Override
	public boolean isRepeatable() {
		return false;
	}

	@Override
	public long getContentLength() {
		return -1;
	}

	@Override
	public InputStream getContent() throws IOException, IllegalStateException {
		return null;
	}

	@Override
	public void writeTo(OutputStream outstream) throws IOException {
		try {
			JAXBContext jaxbContext = JAXBContext.newInstance(content.getClass());
			Marshaller marshaller = jaxbContext.createMarshaller();
			marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
			marshaller.marshal(content, outstream);
			outstream.flush();
		} catch (Exception x) {
			throw new IOException(x);
		}
	}

	@Override
	public boolean isStreaming() {
		return true;
	}

}
