package net.pdynet.odbcproxyclient;

import net.pdynet.odbcproxyclient.jaxb.CloseResponse;
import net.pdynet.odbcproxyclient.jaxb.Column;
import net.pdynet.odbcproxyclient.jaxb.ConnectResponse;
import net.pdynet.odbcproxyclient.jaxb.ExecuteResponse;
import net.pdynet.odbcproxyclient.jaxb.Row;
import net.pdynet.odbcproxyclient.jaxb.Rows;
import net.pdynet.odbcproxyclient.jaxb.SelectResponse;
import net.pdynet.odbcproxyclient.jaxb.Value;

public class OdbcProxyClientTest {
	
	public void test1() {
		try {
			OdbcProxyClient proxyClient = new OdbcProxyClient();
			
			String connectionString = "Driver={Microsoft Excel Driver (*.xls, *.xlsx, *.xlsm, *.xlsb)};DBQ=D:\\UserData\\Documents\\openxml01.xlsx;ReadOnly=False;";
			ConnectResponse connectResponse = proxyClient.connect(connectionString, false);
			
			if (!connectResponse.isSuccess()) {
				System.out.println(connectResponse.getError());
				return;
			}
			
			String connectionID = connectResponse.getConnectionID();
			System.out.println("connectionID is " + connectionID);
			System.out.println("connection will be opened till " + connectResponse.getConnectionAutoCloseTime().toGregorianCalendar().getTime());
			
			String query = "insert into [List1$](JKP, Nzev, Cena, Mnostv, Vpoet, Datum) values ('TestID', 'TestHeader', 156.95, 99, 17.3, '2012-04-01 08:55:34')";
			ExecuteResponse executeResponse = proxyClient.execute(connectionID, query);
			System.out.println(executeResponse.isSuccess());
			System.out.println(executeResponse.getError());
			System.out.println(executeResponse.getAffectedRows());
			
			query = "select * from [List1$]";
			SelectResponse selectResponse = proxyClient.select(connectionID, query);
			
			Rows rows = selectResponse.getRows();
			if (rows != null) {
				for (Row row : rows.getRow()) {
					System.out.println("-------------------------------------");
					for (Column column : row.getColumn()) {
						String header = column.getHeader();
						Value value = column.getValue();
						
						if (value == null) {
							System.out.println(header + " = " + value);
						} else {
							System.out.println(header + " = " + value.getValue() + " (" + value.getType() + ")");
						}
					}
				}
			}
			
			CloseResponse closeResponse = proxyClient.close(connectionID);
			System.out.println("Connection closed: " + closeResponse.isSuccess());
			
		} catch (Exception x) {
			x.printStackTrace();
		}
	}
}
